--[[ Many Minor Tweaks v5.0
Author: birbhorse aka EeveeEuphoria/scorbuny
This is the third do-over of "Many Minor Tweaks", in which this should hopefully be the last one for a good long while. The last two versions were really not well-made, and although this one isn't a masterpiece or anything, this should be much easier to work with now.
Credits
	- lua-users.org for deepcopy (http://lua-users.org/wiki/CopyTable)
    - TrustyGun for Spring Twirl (https://mb.srb2.org/addons/spring-twirl.1213/)
	- ffoxD for Spin Steer (https://mb.srb2.org/addons/ffoxds-lua-dumpster.1429/)
	- Kirb for "Air walk remover" (https://mb.srb2.org/addons/air-walk-remover-with-explanations-and-links.2815/)
	- Krabs and Stonecutter for Anglestand (https://mb.srb2.org/threads/anglestand-1-5-1-angleability.29160/)
	- TehRealSalt for Jump Leniency (https://mb.srb2.org/addons/jump-leniency.2821/)
	- amperbee for PBT3 and helping with a functioning menu system
     __     __            __     __       ________
    /  \   /  \          /  \   /  \     |___  ___|
   /    \_/    \        /    \_/    \       |  |
  /  /\     /\  \      /  /\     /\  \      |  |
 /  /  \   /  \  \    /  /  \   /  \  \     |  |
/__/    \_/    \__\  /__/    \_/    \__\    |__|
                               _____
                ___     ___   |   __|
                 \  \_/  /    |  |__
                  \     /     |__   |
                   \   /       __|  |
                    \_/       |_____|
]]

freeslot("S_PLAY_ANGLEIDLE")
states[S_PLAY_ANGLEIDLE] = {SPR_PLAY, SPR2_WAIT, 16, nil, 0, 0, S_PLAY_ANGLEIDLE}


-- [[[ General Functions ]]] --


local function P_SpawnCoolSkidDust(player, radius, sound)
    local particle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
    local xn = P_RandomChance(FRACUNIT/2)
    local yn = P_RandomChance(FRACUNIT/2)
    if xn then xn = -1 else xn = 1 end
    if yn then yn = -1 else yn = 1 end

    local x = particle.x + (xn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local y = particle.y + (yn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local z = particle.z --+ (P_RandomRange(0, FRACUNIT-1))
    P_TeleportMove(particle, x, y, z)
    particle.tics = 10
    particle.scale = (2*player.mo.scale)/3
    particle.momx = player.mo.momx
    particle.momy = player.mo.momy
    P_SetScale(particle, particle.destscale)
    P_SetObjectMomZ(particle, FRACUNIT, false)
    if player.powers[pw_super] then
        P_SetObjectMomZ(particle, FRACUNIT*3, false)
    end

    if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) then -- smoke looks weird underwater
        particle.state = S_SPLISH1
    end

    if sound then
        S_StartSound(player.mo, sfx_s3k7e)
    end
    return particle -- the one thing the original version of this didn't do, smh smh
end

local function SuperTransition(player) -- trans rights
    if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2) or (player.mo.state == S_PLAY_SUPER_TRANS3) or (player.mo.state == S_PLAY_SUPER_TRANS4) or (player.mo.state == S_PLAY_SUPER_TRANS5) or (player.mo.state == S_PLAY_SUPER_TRANS6))
        return true
    else
        return false
    end
end

local function BasicSuperCheck(player)
    if not P_IsObjectOnGround(player.mo) and player.rings >= 50 and All7Emeralds(emeralds) and not player.powers[pw_super] and (player.playerstate == PST_LIVE) -- basic checks
    and (player.super4all == "on" or (skins[player.mo.skin].flags & SF_SUPER)) -- check to see if player is allowed to be super
    and player.mmtbt.spin < 2 -- make sure player isn't holding spin when jumping; not completely fool proof but it does the job
    and not (player.pflags & PF_THOKKED) and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.pflags & PF_SHIELDABILITY) and (player.pflags & PF_JUMPED) and not SuperTransition(player) -- misc. checks
    and not SuperTransition(player)
    and ((player.powers[pw_shield] == 0) or (player.powers[pw_shield] > 0 and player.superkey != "spin")) -- ensure player doesn't have shield, or can use it w/ different key
    then
        return true
    else
        return false
    end
end

local function GiveSuper(player)
    player.pflags = $ & ~PF_JUMPED
    player.charflags = $1 | SF_SUPER
    if player.supermusic == "off" then
        P_DoSuperTransformation(player, false)
    else
        player.powers[pw_super] = 1
        player.mo.state = S_PLAY_SUPER_TRANS1
        S_StartSound(player.mo, sfx_supert, player)
    end
end

addHook("ThinkFrame", function()
    for player in players.iterate do
        --local player = mo.player
        if not (player and player.valid) then break end -- player does not exist, don't run
        --if not (player == consoleplayer) then break end -- playing player is not player, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
        if player.bot > 0 then break end -- player is bot, don't run

        if not player.mmenuinit then break end

        -- [[ Load in settings ]] --
        player.loadtimer = $ + 1

        local waittime = TICRATE/3
        if netgame then -- want to really be sure players can load in their settings
            waittime = TICRATE*2
        end

        if player.loadtimer > waittime then
            if not player.MMTloaded then
                COM_BufInsertText(player, "exec mmtconf.cfg -noerror")
                player.MMTloaded = true
            end
        end

        -- [[ Controls ]] --

        -- Recurl --
        if (player.recurl != "off" and (player.charability2 == CA2_SPINDASH)) then
            if player.mo.sprite2 == SPR2_SPNG then
                player.UsedSpring = true
            elseif (player.panim == PA_PAIN and not P_PlayerInPain(player)) then
                player.UsedTornado = true
            elseif not player.UsedSpring and not player.UsedTornado and player.panim == PA_FALL and not (player.pflags & PF_SHIELDABILITY) and not (player.charability == CA_FLOAT and (player.pflags & PF_THOKKED)) then
                player.UsedMisc = true
            end

            if player.recurl == "spin" then
                player.MMTrecurlKey = BT_USE
            else
                player.MMTrecurlKey = BT_JUMP
            end


            if not P_IsObjectOnGround(player.mo)
            and ((player.UsedSpring or player.UsedMisc) or (player.UsedTornado and (player.panim == PA_FALL)))
            and (player.cmd.buttons & player.MMTrecurlKey)
            and (player.charability2 == CA2_SPINDASH)
            and player.secondjump == 0 -- prevents weirdness with super sonic
            --and (not player.recurlwait or (player.UsedSpring and player.UsedTornado and player.panim == PA_FALL))
            and player.mo.state != S_PLAY_JUMP then
                player.mo.state = S_PLAY_JUMP
                player.pflags = $1 | PF_JUMPED
                player.pflags = $1 | PF_THOKKED
                S_StartSound(player.mo, sfx_spin, player)
                --if player.MMTrecurlmulti != "on" then player.recurlwait = true end
            end

            if P_IsObjectOnGround(player.mo) then
                player.UsedSpring = false
                player.UsedTornado = false
                player.UsedMisc = false
            end
        end

        -- Uncurl --
        if player.uncurl == "on" then
            if player.denyuncurl and player.mmtbt.spin == 0 then
                player.denyuncurl = false
            end
            -- the function that sets this true is located in the PreThinkFrame hook found in lua_options

            if P_IsObjectOnGround(player.mo)
            and (player.pflags & PF_SPINNING)
            and not player.denyuncurl
            and (player.speed > player.runspeed - player.runspeed/3)
            and player.mmtbt.spin == 1
            then
                player.pflags = $ & ~PF_SPINNING
                player.mo.state = S_PLAY_WALK
                S_StartSound(player.mo,sfx_3db16)
            end

        end

        -- Spin Control --
        if player.spinsteer > 0 then
            if (player.pflags & PF_SPINNING) and not (player.pflags & PF_STARTDASH) and not (player.pflags & PF_JUMPED) and (player.panim == PA_ROLL)
            and (P_IsObjectOnGround(player.mo) or player.spstmidair != "off") then
                if not player.StoredThing then
                    player.StoredThing = player.thrustfactor
                end
                local Value = player.spinsteer
                if not P_IsObjectOnGround(player.mo) and player.spstmidair != "normal" then
                    if player.spstmidair == "lightest" then
                        Value = $/2
                    else
                        Value = $/2 + Value/3
                    end
                end
                player.thrustfactor = (skins[player.mo.skin].thrustfactor)*Value
            elseif player.StoredThing then
                player.thrustfactor = player.StoredThing
                player.StoredThing = nil
            end
        end

        -- Tails Drop Ball --
        if player.tailsball != "off" then
            if ((player.charability == CA_FLY) and (player.charability2 == CA2_SPINDASH) and (skins[player.mo.skin].name != "eggman"))
            and player.panim == PA_ABILITY and (player.cmd.buttons & mmt_ConvertStringKey(player.tailsball)) then
                S_StartSound(player.mo,sfx_3db16)
                player.mo.state = S_PLAY_JUMP
                player.pflags = $1 | PF_JUMPED
                player.pflags = $1 | PF_THOKKED
                player.pflags = $ & ~PF_CANCARRY
            end
        end

        -- Tails Hold Fly --
        if player.holdfly != "off" then
            if (player.powers[pw_tailsfly] > 0) and player.mmtbt.jump > 0 then
                player.fly1 = 1
            end
        end

        -- Speedier Spin --
        if player.speedierspin == "on" then
            if player.powers[pw_sneakers] or player.powers[pw_super] then
                player.speedierspininuse = true
                player.speedierspinrestore = false
                player.maxdash = skins[player.mo.skin].maxdash / 2
                if player.mmtbt.spin == 0 and (player.pflags & PF_STARTDASH) then
                    player.dashspeed = $ * 2
                end
            else
                player.speedierspininuse = false
            end
        else
            player.speedierspininuse = false
        end

        if not player.speedierspininuse and not player.speedierspinrestore then
            player.maxdash = skins[player.mo.skin].maxdash
            player.speedierspinrestore = true
        end

        -- [[ Enhancements ]] --
    
        -- Preserve Shield --
        if player.preserveshield == "on" then
            -- ((player.pflags & PF_FINISHED) or stoppedclock)
            if G_EnoughPlayersFinished() then
                if not player.ShieldAlreadySaved and not G_IsSpecialStage(gamemap) then
                    player.ShieldAfterLevel = player.powers[pw_shield]
                    player.ShieldAlreadySaved = true
                    player.ShieldLevelName = mapheaderinfo[gamemap].lvlttl
                    mmtdebuggerPrint(player, "Saving shield! Shield saved is: " .. player.ShieldAfterLevel)
                end
            elseif player.ShieldAlreadySaved and player.preserveshield == "on" and not G_IsSpecialStage(gamemap) then
                if (player.ShieldLevelName == mapheaderinfo[gamemap].lvlttl) or player.preserveshieldzones == "on" then
                    player.powers[pw_shield] = player.ShieldAfterLevel
                    mmtdebuggerPrint(player, "Shield spawned is: " .. player.ShieldAfterLevel)
                    P_SpawnShieldOrb(player)
                end
                player.ShieldAlreadySaved = false
            end
        end

        -- Water Running --

        if player.waterrunner == "on" and not (skins[player.mo.skin].flags & SF_RUNONWATER) then
            if abs(player.mo.momz) < FRACUNIT and (player.speed >= player.runspeed + player.rowreq) then
               player.charflags = $1|SF_RUNONWATER
            else
               player.charflags = $1 & ~SF_RUNONWATER
            end
        end

        -- Fade Music --
        if player.MMTfademusic == "on" then
            if G_EnoughPlayersFinished() then
                if player.MusicVolume > 0 then
                    player.MusicVolume = $ - 1
                end
            --[[elseif player.mmtusingmenu then
                if player.MusicVolume > 66 then
                    player.MusicVolume = $ - 1
                end]]
            else
                if player.MusicVolume < 101 then
                    player.MusicVolume = $ + 1
                end
            end
        else
            if player.MusicVolume < 101 then
                player.MusicVolume = $ + 1
            end
        end
        if player.MusicVolume < 101 then
            S_SetInternalMusicVolume(player.MusicVolume, player)
        end

        -- Speedy Particles --
        if player.speedyparts == "on" then
            if P_IsObjectOnGround(player.mo) and (player.speed > player.runspeed) then
                local part = P_SpawnCoolSkidDust(player, 16, false)
                part.destscale = player.mo.scale/6+player.mo.scale/5
                part.scalespeed = FRACUNIT/19
            end
        end
        --FixedMul(player.runspeed, 2*FRACUNIT+FixedDiv(3*FRACUNIT, 4*FRACUNIT))
        if player.speedyflames == "on" then
            if P_IsObjectOnGround(player.mo) and not (player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)) and 
            (player.speed > 55*FRACUNIT or (player.speed > 40*FRACUNIT and (player.powers[pw_sneakers] or player.dashmode >= 3*TICRATE))) then
                local part2 = P_SpawnCoolSkidDust(player, 12, false)
                part2.state = S_SPINDUST_FIRE1
                part2.destscale = player.mo.scale/2+player.mo.scale/11
                part2.scalespeed = FRACUNIT/30
                part2.tics = TICRATE
            end
        end

        -- Ring Scattering --

        if player.ringscatter == "on" then
            player.losstime = 0
        end

        -- [[ Super Form Options ]] --

        -- Option 1: Super Button --
        if not G_EnoughPlayersFinished() then
            if player.superkey != "off" then
                if not player.powers[pw_super] then player.charflags = $ & ~SF_SUPER end
                if (player.cmd.buttons & mmt_ConvertStringKey(player.superkey)) and BasicSuperCheck(player) then
                    GiveSuper(player)
                end
                -- super sector
                if P_PlayerTouchingSectorSpecial(player, 4, 6) and All7Emeralds(emeralds) and not player.powers[pw_super] then
                    player.rings = 50
                    GiveSuper(player)
                end
            end
        end
        -- Option 2: Super Cancel --
        if player.cancelsuperkey != "off" and player.powers[pw_super] then
            if (player.cmd.buttons & mmt_ConvertStringKey(player.cancelsuperkey)) and not SuperTransition(player) then
                player.pflags = $1 | PF_THOKKED
                player.powers[pw_flashing] = TICRATE
                player.powers[pw_super] = 0
                player.mo.color = player.skincolor
                P_RestoreMusic(player)
                P_SpawnShieldOrb(player)
            end
        end
        
        -- Option 3: Super Forms for All --
        if player.superkey == "off" then
            if player.super4all == "on" then
                player.charflags = $1 | SF_SUPER
            elseif not (skins[player.mo.skin].flags & SF_SUPER) then
                player.charflags = $ & ~SF_SUPER
            end
        end

        -- Option 5: Super Trail --
        if player.supertrails == "on"
        and player.powers[pw_super] and not player.mo.hyperflashcolor -- prevents conflict with hyper abilities
        and not (player.speed < 4*FRACUNIT and player.mo.momz == 0) then
            local traily = P_SpawnGhostMobj(player.mo)
            traily.fuse = 4
            traily.rollangle = player.mo.rollangle
            if (traily.tracer) then
                traily.tracer.fuse = 4
            end
        end

        -- [[ Misc. Options ]] --

        -- Instant Respawn --
        if player.instantrespawn == "on" then
            if (gametype == GT_COOP) and player.playerstate == PST_DEAD then
                player.playerstate = PST_REBORN
            end
        end

        -- No More Air Walking --
        -- 
        if player.noairwalk == "on" and
        ((player.CoyoteTime == "on" and player.mo.coyoteTime == 0) or (player.CoyoteTime == "off")) -- just something to make things seem smoother
        then
            player.FallingAnimation = true
            if not(P_IsObjectOnGround(player.mo))
            and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
            and not player.powers[pw_carry] then
                player.mo.state = S_PLAY_FALL
            end
        else
            player.FallingAnimation = false
        end

        -- Menu Music --
        if player.menumusic == "on" then
            if player.mmtusingmenu and not player.MusicSet then
                player.MusicSet = true
                S_ChangeMusic("MMTM", true, player)
            end
            if not player.mmtusingmenu and player.MusicSet then
                player.MusicSet = false
                P_RestoreMusic(player)
            end
        else
            if player.MusicSet then
                player.MusicSet = false
                P_RestoreMusic(player)
            end
        end

    end
end)

-- [[ Token to Rings ]] --
addHook("TouchSpecial", function(emeraldtoken, toucher)
	if toucher.type == MT_PLAYER then
		local player = toucher.player
		if not emeraldtoken.CollectedTime and player.TokenToRings == "on" and All7Emeralds(emeralds) then
			P_GivePlayerRings(player, 50)
			P_AddPlayerScore(player, 1000)
			S_StartSound(player.mo, sfx_cdfm66)
			emeraldtoken.CollectedTime = true
			P_KillMobj(emeraldtoken)
			return true
		else
			return false
		end
	end
end, MT_TOKEN)

-- [[ Disable Super Hover ]] --
addHook("JumpSpinSpecial", function(player)
	if player.powers[pw_super] and player.charability == CA_THOK and player.disablesuperhover == "on" then
		return true
	end
end)

-- [[ Spring Twirl ]] --
-- pretty much ported wholesale from the original lua file
local function spring_twirl(mo)
	--assign player to a variable to make our lives a little bit easier (and our code a little bit readable)
	local player = mo.player
    if player.SpringTwirlOption == "off" then return end
	--is player.twirl_angle assigned? if not, create it.
	if player.twirl_angle == nil then
		player.spring_twirl = false
		player.twirl_angle = 0	--starts at 0
	end
	--clear the spring twirl flag when we are at 0 momz
	if mo.momz == 0 and player.spring_twirl == true then
		player.spring_twirl = false
		player.steam = false
	end
	--are we currently in the spring animation?
	if (player.panim == PA_SPRING or player.steam) and player.spring_twirl == true then
		--add to our twirl angle
		player.twirl_angle = player.twirl_angle + FixedAngle(mo.momz)
		--make our draw angle twirl angle, therefore showing us spinning when we hit a spring
		player.drawangle = player.twirl_angle
	end
end

local function vertical_spring(thing, toucher)
	--is our toucher a player?
	if toucher.type == MT_PLAYER then
        if toucher.player.SpringTwirlOption == "off" then return end
		--height checks
		if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
			--set spring twirl to true
			toucher.player.spring_twirl = true
			toucher.player.twirl_angle = toucher.angle
		end
		--ugh why doesn't mobjcollide take height into account
	end
end

local function diagonal_spring(thing, toucher)
	if toucher.type == MT_PLAYER then
          if toucher.player.SpringTwirlOption == "off" then return end
		--height checks
		if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
			--set spring twirl to false
			--this is only so that if we go from a vertical spring to a diagonal one, we don't twirl again
			--we don't have to do this for the horziontal springs since they don't put you into your spring animation
			toucher.player.spring_twirl = false
		end
	end
end

addHook("MobjThinker", spring_twirl, MT_PLAYER)

addHook("MobjCollide", vertical_spring, MT_REDSPRING)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRING)
addHook("MobjCollide", vertical_spring, MT_BLUESPRING)
addHook("MobjCollide", vertical_spring, MT_SPRINGSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRINGBALL)
addHook("MobjCollide", vertical_spring, MT_REDSPRINGBALL)

addHook("MobjCollide", diagonal_spring, MT_REDDIAG)
addHook("MobjCollide", diagonal_spring, MT_YELLOWDIAG)
addHook("MobjCollide", diagonal_spring, MT_BLUEDIAG)


addHook("MobjCollide", function(thing, tmthing) -- adding in the spring twirl for steam, because i said so bitch
	if tmthing and tmthing.player then
		local player = tmthing.player
		if player.SpringTwirlOption == "off" then return end
		if thing.state == S_STEAM1 and abs(tmthing.z-thing.z) <= thing.height then
			player.spring_twirl = true
			player.twirl_angle = tmthing.angle
			player.steam = true -- turns out this is unnessecary now, but i'm leaving it in
			player.mo.state = S_PLAY_SPRING
			return true -- this causes this to run multiple times, but that's okay, it forces the player into the spring state and not much else
		end
	end
end, MT_STEAM, MT_PLAYER)


-- [[ Commands ]] --

COM_AddCommand("mmtmenu", function(player, arg1)
	if not (player and player.valid) then return end
	if not (player.realmo and player.realmo.valid) then return end
	if G_EnoughPlayersFinished() then return end
	if player.playerstate == PST_DEAD then return end

	player.mmtusingmenu = not $
    if not player.mmtusingmenu then
        MMT_SaveOptions(player)
    end
	player.ReadHelp = true
end)

--sample: mmtload "Recurl" "off"

COM_AddCommand("mmtload", function(player, arg1, arg2, arg3)
	if not (player and player.valid) then return end
	if not (player.realmo and player.realmo.valid) then return end

	if not arg1 then
		CONS_Printf(player, "NOTICE! This is not intended to be used by the player.")
		CONS_Printf(player, "This is meant for save/load functionality in servers.")
		return
	end

	-- player.mmtoptions[player.mmthud.ChangingOption].set[i]

	if arg1 == "MMTLOADCOMPLETE!!!" then
        if player.fullyloaded then return end
		CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x8C Settings loaded" .. "\x80!")
		if player.ErrorLoading then
			CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x82 Some of your previous settings could not be loaded properly" .. "\x80.")
			S_StartSound(nil, sfx_notadd, player)
		else
			S_StartSound(nil, sfx_addfil, player)
		end
        player.fullyloaded = true
		player.ReadHelp = true
		return
	end

    local Leg = false
    local Name = arg1
    for n = 1, #mmt_MainMenu do -- For every entry in the menu
        if mmt_MainMenu[n].jumptostring then
            local tabler = mmt_ListOTables[mmt_MainMenu[n].jumptostring]
            local Success = false
            if not tabler.textonly then -- not needed, just a bit of optimization really
                for index = 1, #tabler do -- every option menu found inside main menu
                    local entry = tabler[index]
                    if entry.name == arg1 then -- argument equals name, proceed onward
                        local SafeToGo = false
                        if entry.stringoptions then
                            for index2, value in ipairs(entry.stringoptions) do
                                if value == arg2 then
                                    SafeToGo = true
                                end
                            end
                        elseif entry.range then -- presumed number, clamp up or down or all around
                            if not type(arg2) == "number" then
                                Success = false
                                break
                            end
                            player[entry.prop] = max(entry.range[1], min(entry.range[2], arg2))
                            SafeToGo = false
                            Success = true
                        end
                        
                        if SafeToGo then
                            player[entry.prop] = arg2
                            Success = true
                        end
                        if Success then
                            Leg = true
                        elseif entry.name != nil then
                            Name = entry.name
                        end
                    end
                end
            end
        end
    end
    if not Leg then
        CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x85 Could not load option for \"" + Name .. "\"\x80!")
        player.ErrorLoading = true
    end
end)